

#' @title Berkeley Child Guidance Study Data for Females
#'
#' @description A subset of the [bsitar::berkeley] data, containing
#'   longitudinal growth data for 70 females (aged 8 to 18 years).
#'
#' @details Detailed information about the full dataset can be found in the
#'   [bsitar::berkeley] data.
#'
#' @name berkeley_exdata
#' @docType data
#' @format A data frame with the following 3 variables:
#' \describe{
#' \item{id}{A factor variable identifying the subject.}
#' \item{age}{Age in years, numeric vector.}
#' \item{height}{Height in centimeters, numeric vector.}
#' }
#'
#' @keywords datasets
#'
#' @return A data frame with 3 columns.
#' @inherit berkeley author
"berkeley_exdata"
