

#' @title Model Fit to the Berkeley Child Guidance Study Data for Females
#'
#' @description Bayesian SITAR model fit to the [bsitar::berkeley_exdata]
#'   dataset (70 females, aged 8 to 18 years).
#'
#' @details Detailed information about the data can be found in the
#'   [bsitar::berkeley_exdata] dataset.
#'
#' @name berkeley_exfit
#' @docType data
#' @format A model fit object containing a summary of the posterior draws.
#'
#' @keywords datasets
#'
#' @return An object of class \code{bgmfit} containing the posterior draws.
#'
#' @inherit berkeley author
"berkeley_exfit"
